---
title: GET /tasks/{task_id}/structured-contents/{content_id}/versions
slug: content-marketing-platform/api/get-taskstaskidstructured-contentscontentidversions
docTags: 
createdAt: 2026-10-18T12:23:32.321Z
---

{
  "id": "UdcrpocSwMYrPsaKvbcuH",
  "type": "api-oas-v2",
  "data": {
    "method": "GET",
    "url": "https://api.cmp.optimizely.com/v3/tasks/{task_id}/structured-contents/{content_id}/versions",
    "servers": [
      {
        "url": "https://api.cmp.optimizely.com/v3/tasks/{task_id}/structured-contents/{content_id}/versions",
        "description": "v3 version of Optimizely CMP Open API"
      }
    ],
    "name": "GET /tasks/{task_id}/structured-contents/{content_id}/versions",
    "description": "<p>Experimental Get the list of versions of a task structured content, newest first. These are the versions that CMP lists for the content.</p>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [
        {
          "kind": "required",
          "name": "task_id",
          "type": "string",
          "example": "645cb61c966d0c591320f636",
          "description": "Unique identifier of the task"
        },
        {
          "kind": "required",
          "name": "content_id",
          "type": "string",
          "example": "a24b834428a043ab8caed1ded4606f7d",
          "description": "Unique identifier of the structured content"
        }
      ],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [
        {
          "kind": "optional",
          "name": "offset",
          "type": "integer",
          "example": 5,
          "description": "<p>Starting index of results (zero indexed)</p>",
          "default": 0,
          "minimum": 0
        },
        {
          "kind": "optional",
          "name": "page_size",
          "type": "integer",
          "example": 15,
          "description": "Number of results to return per page",
          "default": 10,
          "minimum": 1,
          "maximum": 100
        }
      ],
      "bodyDataParameters": [],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "OAuth2",
          "name": "OAuth2",
          "kind": "optional",
          "type": "oauth2",
          "oauth2Flows": {
            "clientCredentials": {
              "tokenUrl": "https://accounts.cmp.optimizely.com/o/oauth2/v1/token",
              "scopes": {}
            },
            "authorizationCode": {
              "authorizationUrl": "https://accounts.cmp.optimizely.com/o/oauth2/v1/auth",
              "tokenUrl": "https://accounts.cmp.optimizely.com/o/oauth2/v1/token",
              "scopes": {
                "openid": "Grants the ability to receive a unique identifier for the user.",
                "profile": "Grants access to user profile information.",
                "offline_access": "Grants the ability to refresh access_token using the refresh token even when user is not present (not logged in)."
              }
            }
          },
          "requiredScopes": [
            "openid",
            "profile",
            "offline_access"
          ]
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "List of versions of the task structured content",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "TaskStructuredContentVersionListResponse",
            "schema": [
              {
                "name": "data",
                "kind": "required",
                "type": "array",
                "description": "<p>List of versions of the task structured content, newest first</p>",
                "modelRef": "#/components/schemas/TaskStructuredContentVersion",
                "customType": "TaskStructuredContentVersion[]",
                "schema": [
                  {
                    "name": "version_guid",
                    "kind": "required",
                    "type": "string",
                    "description": "<p>Unique identifier of the version, as CMP lists it. A version is created when the content or any of its nested contents changes. This identifier is not the same as the <code>version_guid</code> of <code>latest_fields_version</code> or the <code>version_id</code> of the <code>/structured-content</code> endpoints, and those endpoints do not accept it.</p>",
                    "example": "31a6d15b09c54a04935203eb958ae058"
                  },
                  {
                    "name": "created_at",
                    "kind": "required",
                    "type": "string<date-time>",
                    "description": "<p>Date and time on which the version was created, in ISO 8601 UTC format</p>",
                    "example": "2026-10-02T09:15:00Z",
                    "format": "date-time"
                  },
                  {
                    "name": "created_by",
                    "kind": "required",
                    "type": "string",
                    "description": "Unique identifier of the user who created the version",
                    "example": "5c52cc153db27d0e5141146f"
                  },
                  {
                    "name": "source_metadata",
                    "kind": "required",
                    "type": "string",
                    "nullable": true,
                    "description": "Source metadata of the version",
                    "example": ""
                  },
                  {
                    "name": "links",
                    "kind": "required",
                    "type": "object",
                    "description": "Meta links",
                    "example": "",
                    "schema": [
                      {
                        "name": "structured_content",
                        "kind": "required",
                        "type": "string",
                        "description": "URL of the task structured content",
                        "example": "https://api.cmp.optimizely.com/v3/tasks/645cb61c966d0c591320f636/structured-contents/a24b834428a043ab8caed1ded4606f7d"
                      },
                      {
                        "name": "web_urls",
                        "kind": "required",
                        "type": "object",
                        "description": "Web URLs",
                        "example": "",
                        "schema": [
                          {
                            "name": "self",
                            "kind": "required",
                            "type": "string",
                            "description": "Web URL of the version of the structured content in the task",
                            "example": "https://cmp.optimizely.com/go/5c52cc153db27d0e5141146f/tasks/645cb61c966d0c591320f636/structured-contents/a24b834428a043ab8caed1ded4606f7d/versions/31a6d15b09c54a04935203eb958ae058"
                          }
                        ]
                      }
                    ]
                  }
                ]
              },
              {
                "name": "pagination",
                "kind": "required",
                "type": "object",
                "description": "",
                "complexType": "allOf",
                "complexItems": [
                  {
                    "name": "Pagination",
                    "description": "",
                    "modelRef": "#/components/schemas/Pagination",
                    "schema": [
                      {
                        "name": "next",
                        "kind": "required",
                        "type": "string",
                        "nullable": true,
                        "description": "URL to the next page",
                        "example": "https://api.cmp.optimizely.com/<some-path-to-next-page>?offset=10&page_size=10"
                      },
                      {
                        "name": "previous",
                        "kind": "required",
                        "type": "string",
                        "nullable": true,
                        "description": "URL to the previous page",
                        "example": ""
                      }
                    ]
                  },
                  {
                    "name": "object",
                    "description": "",
                    "schema": [
                      {
                        "name": "next",
                        "kind": "optional",
                        "type": "string",
                        "nullable": true,
                        "description": "",
                        "example": "https://api.cmp.optimizely.com/v3/tasks/645cb61c966d0c591320f636/structured-contents/a24b834428a043ab8caed1ded4606f7d/versions?offset=10&page_size=10"
                      }
                    ]
                  }
                ],
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/TaskStructuredContentVersionListResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "400",
        "description": "Client error",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "example": "{\"message\":\"Unsupported arguments: a,b,c\"}",
            "description": "Error payload",
            "customType": "Error",
            "schema": [
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "Message describing the error",
                "example": "Not found"
              },
              {
                "name": "errors",
                "kind": "optional",
                "type": "map",
                "description": "Additional information",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/Error",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Authorization error",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "example": "{\"message\":\"Unauthorized\"}",
            "description": "Error payload",
            "customType": "Error",
            "schema": [
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "Message describing the error",
                "example": "Not found"
              },
              {
                "name": "errors",
                "kind": "optional",
                "type": "map",
                "description": "Additional information",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/Error",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "403",
        "description": "Permission error",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "example": "{\"message\":\"You do not have the permission to perform this operation\"}",
            "description": "Error payload",
            "customType": "Error",
            "schema": [
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "Message describing the error",
                "example": "Not found"
              },
              {
                "name": "errors",
                "kind": "optional",
                "type": "map",
                "description": "Additional information",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/Error",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "404",
        "description": "Not found error",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "example": "{\"message\":\"Resource not found\"}",
            "description": "Error payload",
            "customType": "Error",
            "schema": [
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "Message describing the error",
                "example": "Not found"
              },
              {
                "name": "errors",
                "kind": "optional",
                "type": "map",
                "description": "Additional information",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/Error",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "FQZmwEgwFIIYs6Wx_GN6x",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request GET \\\n     --url 'https://api.cmp.optimizely.com/v3/tasks/{task_id}/structured-contents/{content_id}/versions?offset=5&page_size=10' \\\n     --header 'accept: application/json'"
        },
        {
          "id": "alY2uaV0V89qrofC9EqyB",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar requestOptions = {\n   method: 'GET',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.cmp.optimizely.com/v3/tasks/{task_id}/structured-contents/{content_id}/versions?offset=5&page_size=10\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "wuhstZQ-eaIgyrvWXeSZS",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.cmp.optimizely.com/v3/tasks/{task_id}/structured-contents/{content_id}/versions?offset=5&page_size=10\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Get.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "-H0PwYpcp-Ct-zbwr2l_J",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.cmp.optimizely.com/v3/tasks/{task_id}/structured-contents/{content_id}/versions?offset=5&page_size=10\"\n\npayload = {}\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"GET\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "FQZmwEgwFIIYs6Wx_GN6x"
    },
    "results": {
      "languages": [
        {
          "id": "UvK_Up8FwthBXp3xxDpfK",
          "language": "200",
          "code": "// List of versions of the task structured content\n{\n  \"data\": [\n    {\n      \"version_guid\": \"31a6d15b09c54a04935203eb958ae058\",\n      \"created_at\": \"2026-10-02T09:15:00Z\",\n      \"created_by\": \"5c52cc153db27d0e5141146f\",\n      \"source_metadata\": \"\",\n      \"links\": {\n        \"structured_content\": \"https://api.cmp.optimizely.com/v3/tasks/645cb61c966d0c591320f636/structured-contents/a24b834428a043ab8caed1ded4606f7d\",\n        \"web_urls\": {\n          \"self\": \"https://cmp.optimizely.com/go/5c52cc153db27d0e5141146f/tasks/645cb61c966d0c591320f636/structured-contents/a24b834428a043ab8caed1ded4606f7d/versions/31a6d15b09c54a04935203eb958ae058\"\n        }\n      }\n    }\n  ],\n  \"pagination\": {}\n}"
        },
        {
          "id": "8y93eGvDRphj6d-4rKK8O",
          "language": "400",
          "code": "// Client error\n{\n  \"message\": \"Not found\",\n  \"errors\": \"\"\n}"
        },
        {
          "id": "agtH2O0gcWslYszo4PDFg",
          "language": "401",
          "code": "// Authorization error\n{\n  \"message\": \"Not found\",\n  \"errors\": \"\"\n}"
        },
        {
          "id": "HUO8nCkAPWel7vkhuEWRX",
          "language": "403",
          "code": "// Permission error\n{\n  \"message\": \"Not found\",\n  \"errors\": \"\"\n}"
        },
        {
          "id": "-LgM8UiIWllBUM-E66d3D",
          "language": "404",
          "code": "// Not found error\n{\n  \"message\": \"Not found\",\n  \"errors\": \"\"\n}"
        }
      ],
      "selectedLanguageId": "UvK_Up8FwthBXp3xxDpfK"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}